#include <bsp.h>
#include "drv.h"
#include <stdio.h>
#include <rtems/libio.h>
#include <rtems/error.h>

volatile static char drv_buffer[16];
volatile unsigned int tptr;
volatile unsigned int rptr;

rtems_device_driver drv_init(rtems_device_major_number major,   rtems_device_minor_number minor, void * context)
{
	rtems_status_code 	status;

	printk("DRIVER: drv_init\n\r");
	status = rtems_io_register_name("/dev/test", major, minor);
	if (status != RTEMS_SUCCESSFUL){
		printk("FATAL ERROR: %s\n", rtems_status_text(status));
		rtems_fatal_error_occurred (status);
	}
        rptr=0;
	tptr=0;

	return RTEMS_SUCCESSFUL;	
}

rtems_device_driver drv_open(rtems_device_major_number major,   rtems_device_minor_number minor, void * context)
{
	return RTEMS_SUCCESSFUL;	
}

rtems_device_driver drv_close(rtems_device_major_number major,   rtems_device_minor_number minor, void * context)
{
	return RTEMS_SUCCESSFUL;	
}

rtems_device_driver drv_read(rtems_device_major_number major,   rtems_device_minor_number minor, void * context)
{
	rtems_libio_rw_args_t  *rw_args = context;
	uint32_t 		count=rw_args->count;
	char	       *buffer = rw_args->buffer;
        uint32_t bytes_moved=0;
        while(count--)
	{
	  while(rptr==tptr)
	    if(bytes_moved)
	     goto done;
	  *buffer++=drv_buffer[rptr];
	  rptr=(rptr+1)%sizeof(drv_buffer);
	  bytes_moved++;
	}	
done:
	rw_args->bytes_moved=bytes_moved;
	return RTEMS_SUCCESSFUL;
}


rtems_device_driver drv_write(rtems_device_major_number major,   rtems_device_minor_number minor, void * context)
{
	rtems_libio_rw_args_t  *rw_args = context;
	uint32_t 		count=rw_args->count;
	char	       *buffer = rw_args->buffer;
        uint32_t bytes_moved=0;
        while(count--)
	{
	  while(rptr==((tptr+1)%sizeof(drv_buffer)))
	    if(bytes_moved)
	     goto done;
	  drv_buffer[tptr]=*(buffer++);
	  tptr=(tptr+1)%sizeof(drv_buffer);
	  bytes_moved++;
	}	
done:
	rw_args->bytes_moved=bytes_moved;
	return RTEMS_SUCCESSFUL;
}

