/*  system.h
 *
 *  This include file contains information that is included in every
 *  function in the test set.
 *
 *  COPYRIGHT (c) 2007.
 *  Technical University of Lodz.
 *
 */

#include <rtems.h>
#include "drv.h"

/* functions */

rtems_task Init(
  rtems_task_argument argument
);

/* configuration information */

#include <bsp.h> /* for device driver prototypes */

#define CONFIGURE_APPLICATION_NEEDS_CONSOLE_DRIVER

#define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER

#define CONFIGURE_MAXIMUM_TASKS            10

#define CONFIGURE_RTEMS_INIT_TASKS_TABLE

#define CONFIGURE_USE_IMFS_AS_BASE_FILESYSTEM

#define CONFIGURE_LIBIO_MAXIMUM_FILE_DESCRIPTORS 50

#define CONFIGURE_MICROSECONDS_PER_TICK    64000


#define CONFIGURE_EXECUTIVE_RAM_SIZE        (512*1024)
#define CONFIGURE_MAXIMUM_SEMAPHORES        20
#define CONFIGURE_MAXIMUM_MESSAGE_QUEUES    20
#define CONFIGURE_MAXIMUM_TIMERS	    10


#define CONFIGURE_INIT_TASK_STACK_SIZE    (8*1024)
#define CONFIGURE_INIT_TASK_PRIORITY    50
#define CONFIGURE_INIT_TASK_INITIAL_MODES (RTEMS_PREEMPT | \
		RTEMS_NO_TIMESLICE | \
		RTEMS_NO_ASR | \
		RTEMS_INTERRUPT_LEVEL(0))


/* drivers area */
#define CONFIGURE_HAS_OWN_DEVICE_DRIVER_TABLE

#ifdef CONFIGURE_INIT
rtems_driver_address_table       Device_drivers[3] = 
{
	 CONSOLE_DRIVER_TABLE_ENTRY,
	 CLOCK_DRIVER_TABLE_ENTRY,
	 TEST_DRIVER_TABLE_ENTRY
};
#endif
/* end of drivers area */

#include <rtems/confdefs.h>


/* end of include file */
