
#define CONFIGURE_INIT
#include "system.h"
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h> 
#include <rtems/error.h> 
#include <errno.h>
#include <termios.h>
#include "drv.h"

rtems_task Reader(rtems_task_argument);
rtems_task Writer(rtems_task_argument);


rtems_id Task_id[2];		/* array of task ids */
rtems_name Task_name[2];	/* array of task names */

rtems_task
Init (rtems_task_argument argument)
{

  rtems_status_code status;

  Task_name[0] = rtems_build_name ('D', 'M', 'C', '1');
  Task_name[1] = rtems_build_name ('D', 'M', 'C', '2');

  status =
    rtems_task_create (Task_name[0], 40, RTEMS_MINIMUM_STACK_SIZE * 2,
		       RTEMS_PREEMPT|RTEMS_TIMESLICE, RTEMS_DEFAULT_ATTRIBUTES,
		       &Task_id[0]);
		       
  if (status != RTEMS_SUCCESSFUL)
    rtems_panic ("Can't create task 1:", rtems_status_text (status));
		       
  status =
    rtems_task_create (Task_name[1], 40, RTEMS_MINIMUM_STACK_SIZE * 2,
		       RTEMS_PREEMPT|RTEMS_TIMESLICE, RTEMS_DEFAULT_ATTRIBUTES,
		       &Task_id[1]);

  if (status != RTEMS_SUCCESSFUL)
    rtems_panic ("Can't create task 2:", rtems_status_text (status));

  status = rtems_task_start (Task_id[0], Reader, 1);

  if (status != RTEMS_SUCCESSFUL)
    rtems_panic ("Can't start task 1:", rtems_status_text (status));

  status = rtems_task_start (Task_id[1], Writer, 2);

  if (status != RTEMS_SUCCESSFUL)
    rtems_panic ("Can't start task 2:", rtems_status_text (status));

  status = rtems_task_delete (RTEMS_SELF);
}
