#ifndef __drv_H__
#define __drv_H__

#include <rtems.h>

#define TEST_DRIVER_TABLE_ENTRY \
	{drv_init, drv_open, drv_close, drv_read, drv_write, drv_ioctl}


struct pointers
{
uint32_t rptr;
uint32_t tptr;
};

#define DEV_IO_MAGIC			0xc3
#define IOCTL_DRV_READ _IOR(DEV_IO_MAGIC,0x01,sizeof(struct pointers))

rtems_device_driver drv_init(rtems_device_major_number,   rtems_device_minor_number, void *);
rtems_device_driver drv_open(rtems_device_major_number,   rtems_device_minor_number, void *);
rtems_device_driver drv_close(rtems_device_major_number,   rtems_device_minor_number, void *);
rtems_device_driver drv_read(rtems_device_major_number,   rtems_device_minor_number, void *);
rtems_device_driver drv_write(rtems_device_major_number,   rtems_device_minor_number, void *);
rtems_device_driver drv_ioctl(rtems_device_major_number,   rtems_device_minor_number, void *);

#endif //__drv_H__
